



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【转】Java 多线程（四） 多线程访问成员变量与局部变量</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【转】Java 多线程（四） 多线程访问成员变量与局部变量</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-02 06:11:21 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>原文网址：http://www.cnblogs.com/mengdd/archive/2013/02/16/2913659.html</p>
<p>先看一个程序例子：</p>
<p>　　</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">public class HelloThreadTest<br />
{<br />
    public static void main(String[] args)<br />
    {<br />
        HelloThread r = new HelloThread();

        Thread t1 = new Thread(r);<br />
        Thread t2 = new Thread(r);

        t1.start();<br />
        t2.start();

    }

}

class HelloThread implements Runnable<br />
{<br />
    int i;

    @Override<br />
    public void run()<br />
    {

        while (true)<br />
        {<br />
            System.out.println("Hello number: " + i++);

            try<br />
            {<br />
                Thread.sleep((long) Math.random() * 1000);<br />
            }<br />
            catch (InterruptedException e)<br />
            {<br />
                e.printStackTrace();<br />
            }

            if (50 == i)<br />
            {<br />
                break;<br />
            }<br />
        }

    }<br />
}</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>　　该例子中，HelloThread类实现了Runnable接口，其中run()方法的主要工作是输出"Hello number: "字符串加数字i，并且同时递增i，当i到达50时，退出循环。</p>
<p>　　main()方法中生成了一个HelloThread类的对象r，并且利用这个<strong>一个对象</strong>生成了两个线程。</p>
<p>　　程序的执行结果是：顺次打印了0到49的数字，共50个数字。</p>
<p>　　这是因为，<strong>i是成员变量，则HelloThread的对象r只包含这一个i，两个Thread对象因为由r构造，所以共享了同一个i</strong>。</p>
<p>　　当我们改变代码如下时（原先的成员变量i被注释掉，增加了方法中的局部变量i）：</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">public class HelloThreadTest<br />
{<br />
    public static void main(String[] args)<br />
    {<br />
        HelloThread r = new HelloThread();

        Thread t1 = new Thread(r);<br />
        Thread t2 = new Thread(r);

        t1.start();<br />
        t2.start();

    }

}

class HelloThread implements Runnable<br />
{<br />
    // int i;<br />
    // 若i是成员变量，则HelloThread的对象r只包含这一个i，两个Thread对象因为由r构造，所以共享了同一个i<br />
    // 打印结果是0到49的数字<br />
    @Override<br />
    public void run()<br />
    {<br />
        int i = 0;<br />
        // 每一个线程都会拥有自己的一份局部变量的拷贝<br />
        // 线程之间互不影响<br />
        // 所以会打印100个数字，0到49每个数字都是两遍<br />
        while (true)<br />
        {<br />
            System.out.println("Hello number: " + i++);

            try<br />
            {<br />
                Thread.sleep((long) Math.random() * 1000);<br />
            }<br />
            catch (InterruptedException e)<br />
            {<br />
                e.printStackTrace();<br />
            }

            if (50 == i)<br />
            {<br />
                break;<br />
            }<br />
        }

    }<br />
}</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
<p>　　如注释中所述，<strong>由于局部变量对于每一个线程来说都有自己的拷</strong>贝，所以各个线程之间不再共享同一个变量，输出结果为100个数字，实际上是两组，每组都是0到49的50个数字，并且两组数字之间随意地穿插在一起。　</p>
<p><strong>得到的结论如下：</strong></p>
<p>　　<strong>如果一个变量是成员变量</strong>，那么多个线程对<strong>同一个对象</strong>的成员变量进行操作时，它们对该成员变量是彼此影响的，也就是说一个线程对成员变量的改变会影响到另一个线程。</p>
<p>　　<strong>如果一个变量是局部变量</strong>，那么每个线程都会有一个该局部变量的拷贝（即便是同一个对象中的方法的局部变量，也会对每一个线程有一个拷贝），一个线程对该局部变量的改变不会影响到其他线程。</p>
<h2>参考资料</h2>
<p>　　圣思园张龙老师Java SE系列视频教程。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvg1zqx.html">解决mysql too many connections的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/4950g0v8.html">PYTHON文件操作（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/3901v4j8.html">浅谈Java五大设计原则之观察者模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j7y2w9.html">Kanzi Studio中的概念</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93mx008.html">mysql&colon; you can&amp;&num;39&semi;t specify target table 问题解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qymwzmq.html">POJ 2318 TOYS【叉积&plus;二分】</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v2p538.html">c&num;中操作word文档-三、MSDN文档</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m7lxeq.html">Extjs利用vtype验证表单</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn12v0g8.html">GetPrivateProfileStringA的文件名要小心写</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wg6xwq.html">（POJ 3026） Borg Maze    最小生成树&plus;bfs</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x7gev8.html">uEditor独立图片上传</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mk07kq.html">ecshop优化修改sitemap&period;xml到根目录</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zov3kvq.html">ios控件 UIViewController</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kdnj69.html">Docker（九）：Docker容器卷插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1y44g9.html">SD从零开始19-20</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vr716q.html">JDK1&period;6新特性，WebService强化</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1npn69.html">Java 第二次实验20145104 张家明</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ko5g27q.html">NOSQL之REDIS</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkpzdd8.html">linux下jdk&comma;tomcat的安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/963w6gn9.html">EBS报错FRM-92095：Oracle JInitiator版本太旧，请安装版本1&period;1&period;8&period;2或更高版本</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9j0od74q.html">OpenRisc-41-or1200的cache模块分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7m504gq.html">JavaScript MVC 框架&lbrack;转载&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mn5xd2q.html">利用MyEclipse的ant插件生成Hibernate的映射文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1gx6m9.html">java JMS消息队列</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1e4mr9.html">Thinkpad Edge E440 Ubuntu14&period;04 无线网卡驱动 解决</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1z7n259.html">单向链表JAVA代码</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rd2pzm8.html">sql 常用语法汇总</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wzejwq.html">【网络流&num;9】POJ 2135 Farm Tour 最小费用流 - 《挑战程序设计竞赛》例题</a>
			</li>
						<li><a href="https://www.batexi.com/a/93x42wn9.html">php获取某个目录下面文件的内容</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pj44w49.html">linux学习笔记&amp;lt&semi;命令介绍&amp;gt&semi;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
